            /* All of the .c files include this header file */

/*
 *         Copyright (C) Argonne National Laboratory
 *
 *   Argonne does not guarantee this software in any manner and is
 *   not responsible for any damages that may result from its use.
 *   Furthermore, Argonne does not provide any formal support for this
 *   software.  This is an experimental program.  This software
 *   or any part of it may be freely copied and redistributed,
 *   provided that this paragraph is included in each source file.
 *
 */


#include <stdio.h>

#include <sys/time.h> */
#include <sys/resource.h>

#define MAX_LONG_INT 2147483647  /* a big integer (must fit into long) */

#define MAX_INT      2147483647

#define MAX_NAME 51         /* maximum # of chars in any symbol (including '\0') */

#define MAX_BUF 5000        /* maximum # of chars in input string (including '\0') */

#define MAX_VARS 64         /* maximum # of distinct variables in clause */
#define VAR_TYPE unsigned short  /* must be able to hold MAX_VARS * max_literals */

#define FPA_SIZE 50         /* size of FPA hash tables */

#define TERM 0              /* not an atom */
#define NORM_ATOM 1         /* normal atom */
#define ANSWER 4            /* answer literal atom */

                        /* types of unification property tree */
#define UNIFY 1
#define INSTANCE 2
#define MORE_GEN 3

#define BOOL char
#define FALSE 0
#define TRUE 1
#define UNDEFINED -1
#define NOT_SPECIFIED 0

/*------------------ END OF ALL GLOBAL CONSTANT DEFINITIONS ------------------*/

#include "terms.h"

#include "cos.h" /* Flags and stuff (#define's) */
#include "fun.h" /* Function prototypes */

        /* The rest of this file is communal (global) variables.    */
        /* Names of global variables have first letter capitalized. */

#ifdef IN_MAIN
#define CLASS         /* empty string if included by main program */
#else
#define CLASS extern  /* extern if included by anything else */
#endif

/* lists of clauses */

CLASS struct list *Axioms;
CLASS struct list *Sos;
CLASS struct list *Passive;

/* CLASS int Ignore_sym_num; */

CLASS struct {  /* Flags are boolean valued options */
    char *name;
    int val;
    } Flags[MAX_FLAGS];

/* statistics */

CLASS long Stats[MAX_STATS];

